*,
*::before,
*::after {
    box-sizing: border-box;
}

/* Custom Properties */

:root {
    --ff-primary: 'Source Sans Pro', sans-serif;
    --ff-secondary: 'Source Code Pro', monospace;

    --fw-reg: 300;
    --fw-bold: 900;

    --clr-bg: #18191A;
    --clr-dark: ;
    --clr-text: white;
    --clr-accent: #00868b;

    --fs-h1: 3rem;
    --fs-h2: 2.25rem;
    --fs-h3: 1.25rem;
    --fs-body: 1rem;

    --bs: 3px 3px 20px rgba(51, 51, 51, 0.5);
}

@media (min-width: 800px){
    :root {
        --fs-h1: 4rem;
        --fs-h2: 3.75rem;
        --fs-h3: 1.5rem;
        --fs-body: 1.125rem;
    }
}

/* General Styles */

html {
    scroll-behavior: smooth;
}

body {
    background: var(--clr-bg);
    color: var(--clr-text);
    margin: 0;
    font-family: var(--ff-primary);
    font-size: var(--fs-body);
    line-height: 1.6;
}

section {
    padding: 5em 2em;
}

img {
    display: block;
    max-width: 100%;
}

strong { font-weight: var(--fw-bold) !important; }

:focus {
    outline: 3px solid var(--clr-accent);
    outline-offset: 3px;
}

/* Buttons */

.btn {
    display: inline-block;
    padding: 0.5em 2.5em;
    background: var(--clr-accent);
    color: var(--clr-text);
    text-decoration: none;
    cursor: pointer;
    font-size: 0.8rem;
    text-transform: uppercase;
    letter-spacing: 2px;
    font-weight: var(--fw-bold);
    transition: transform 200ms ease-in-out;
}

.btn:hover {
    transform: scale(1.1);
}

/* Typography */

h1,
h2,
h3 {
    line-height: 1;
    margin: 0;
}

h1 { font-size: var(--fs-h1); }
h2 { font-size: var(--fs-h2); }
h3 { font-size: var(--fs-h3); }

.section__title {
    margin-bottom: .25em;
}

.section__title--intro {
    font-weight: var(--fw-reg);
}

.section__title--intro strong {
    display: block;
}

.section__subtitle {
    margin: 0;
    font-size: var(--fs-h3);
}

.section__subtitle--intro,
.section__subtitle--about,
.section__subtitle--tech {
    background: var(--clr-accent);
    padding: .25em 1em;
    font-family: var(--ff-secondary);
    margin-bottom: 1em;
}

.section__subtitle--projects {
    color: var(--clr-accent);
    font-weight: var(--fw-bold);
    margin-bottom: 1em;
}

/* Header */

header {
    display: flex;
    justify-content: space-between;
    padding: 1em;
    background: #111;
}

.logo a {
    display: flex;
    align-items: center;
    color: white;

    text-decoration: none;
}

.nav {
    position: fixed;
    background: var(--clr-accent);
    color: var(--clr-text);
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    z-index: 100;

    transform: translateX(100%);
    transition: transform 250ms cubic-bezier(0.5, 0, 0.5, 1);
}

.nav__list {
    list-style: none;
    display: flex;
    height: 100%;
    flex-direction: column;
    justify-content: space-evenly;
    align-items: center;
    margin: 0;
    padding: 0;
}

.nav__link {
    color: inherit;
    font-weight: var(--fw-bold);
    font-size: var(--fs-h2);
    text-decoration: none;
}

.nav__link:hover {
    color: var(--clr-bg);
}

.nav-toggle {
    padding: 0.5em;
    background: transparent;
    border: 0;
    cursor: pointer;
    position: absolute;
    right: 1em;
    top: 2em;
    z-index: 1000;
}

.nav-open .nav {
    transform: translateX(0);
}

.nav-open .hamburger {
    transform: rotate(0.625turn);
}

.nav-open .hamburger::before {
    transform: rotate(90deg) translateX(-6px);
}

.nav-open .hamburger::after {
    opacity: 0;
}

.nav-open .nav-toggle {
    position: fixed;
}

.hamburger {
    display: block;
    position: relative;
}

.hamburger,
.hamburger::before,
.hamburger::after {
    background: var(--clr-text);
    width: 2em;
    height: 3px;
    border-radius: 1em;
    transition: transform 250ms ease-in-out;
}

.hamburger::before,
.hamburger::after {
    content: "";
    position: absolute;
    left: 0;
    right: 0;
}

.hamburger::before { top: 6px; }
.hamburger::after { bottom: 6px; }

/* Intro Section */

.intro {
    position: relative;
}

.intro__img {
    box-shadow: var(--bs);
}

@media (min-width: 600px) {
    .intro {
        display: grid;
        width: min-content;
        margin: 0 auto;
        grid-column-gap: 1em;
        grid-template-areas: 
            "img title"
            "img subtitle";
        grid-template-columns: min-content max-content;
    }

    .intro__img {
        grid-area: img;
        min-width: 250px;
        position: relative;
        z-index: 2;
    }

    .section__subtitle--intro {
        align-self: start;
        grid-column: -1 / 1;
        grid-row: 2;
        text-align: right;
        position: relative;
        left: -1.5em;
        width: calc(100% + 1.5em);
    }
}

/* About Me */

.about-me {
    max-width: 1000px;
    margin: 0 auto;
    padding-bottom: 0;
    margin-bottom: 0;
}

@media (min-width: 600px) {
    .about-me {
        display: grid;
        grid-template-columns: 1fr 200px;
        grid-template-areas: 
            "title img"
            "subtitle img"
            "text img";
        grid-column-gap: 2em;
    }

    .section__title--about {
        grid-area: title;
    }

    .about-me__body {
        grid-row: 3;
    }

    .section__subtitle--about {
        grid-column: 1 / -1;
        grid-row: 2;
        position: relative;
        left: -1em;
        width: calc(100% + 2em);
        padding-left: 2em;
        padding-right: calc(200px + 4em);
    }
}

/* Timeline */

.timeline {
  max-width: 1000px;
  margin: 0 auto;
  margin-top: 35px;
  padding: 15px;
  display: grid;
  grid-template-columns: 40% auto;
  justify-content: center;
}

.timeline ul {
  margin-top: 30px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  list-style: none;
  padding: 0;
}
.timeline li {
  margin-top: 30px;
  position: relative;
  padding: 25px;
}
.timeline li p {
  padding: 0 20px;
  transition: 1.5s;
  height: 50px;
}

.date {
  position: absolute;

  top: 30px;
  left: -50px;
  opacity: 0;
  transition: 1.5s;
  font-size: 12px;
}
.timeline-line {
  background: var(--clr-text);
  width: 4px;
  border-radius: 12px;
  position: relative;
  justify-self: end;
}

.timeline-point {
  border: none;
  position: absolute;

  border-radius: 50%;
  background: var(--clr-text);
  width: 8px;
  height: 8px;

  top: 30px;
  left: -6px;
  transition: 1.5s ease;
}
.timeline-innerline {
  position: absolute;
  background: var(--clr-accent);
  width: 4px;
  height: 0%;

  top: 0%;
  left: 0%;

  transition: 1s linear;
}

@media screen and (min-width: 728px) {
  .timeline {
    display: block;
  }
  .timeline ul {
    flex-direction: row;
  }
  .timeline li {
    margin-top: 0px;
    position: relative;
    width: 100%;
    padding: 0px;
  }
  .timeline li p {
    transform: translateY(-10px);
    opacity: 0;
    /* padding: 0 20px; */
    transition: 1.5s;
  }

  .date {
    opacity: 0;
    transition: 1.5s;
    font-size: 12px;

    position: absolute;
    top: -60px;
    left: 38%;
  }

  .timeline-point {
    width: 15px;
    height: 15px;

    top: -40px;
    left: 40%;
    transition: 1.5s ease;
  }

  .timeline-line {
    width: 100%;
    height: 4px;
  }

  .timeline-innerline {
    position: absolute;
    background: var(--clr-accent);
    width: 0%;
    height: 4px;

    top: 0%;
    left: 0%;

    transition: 1s linear;
    border-radius: 999px;
  }
}



/* Tech */

.technologies {
    max-width: 1000px;
    margin: 0 auto;
}

.technologies__body ul {
    display: grid;
    grid-template-columns: repeat(auto-fit,minmax(250px, 1fr));

    justify-content: space-evenly;
}

.technologies__body li {
    justify-content: space-evenly;
    list-style: none;
}

@media (min-width: 600px) {
    .technologies {
        display: grid;
        grid-template-columns: 1fr 200px;
        grid-template-areas: 
            "title img"
            "subtitle img"
            "text text";
        grid-column-gap: 2em;
    }

    .section__title--tech {
        grid-area: title;
    }

    .technologies__body {
        grid-area: text;
    }

    .section__subtitle--tech {
        grid-column: 1 / -1;
        grid-row: 2;
        position: relative;
        left: -1em;
        width: calc(100% + 2em);
        padding-left: 2em;
        padding-right: calc(200px + 4em);
    }
}

/* Projects */

.my-projects {
    color: var(--clr-text);
    text-align: center;
}

.portfolio {
    display: grid;
    grid-template-columns: repeat(auto-fit,minmax(300px, 1fr));
}

.portfolio__item {
    background: var(--clr-accent);
    overflow: hidden;
}

.portfolio__img {
    transition: 
        transform 750ms cubic-bezier(0.5, 0, 0.5, 1),
        opacity 250ms linear;
}

.portfolio__item:focus {
    position: relative;
    z-index: 2;
}

.portfolio__img:hover,
.portfolio__item:focus .portfolio__img {
    transform: scale(1.2);
    opacity: 0.75;
}

/* Project Gallery */

.image-grid {
    --gap: 16px;
    --num-cols: 3;
    --row-height: 100px;

    box-sizing: border-box;
    padding: var(--gap);

    display: grid;
    grid-template-columns: repeat(var(--num-cols), 1fr);
    grid-auto-rows: var(--row-height);
    gap: var(--gap);
}

.image-grid > img {
    width: 100%;
    height: 100%;
    object-fit: cover;
}

.image-grid-col-2 {
    grid-column: span 2;
}

.image-grid-row-2 {
    grid-row: span 2;
}

@media screen and (max-width: 1024px) {
    .image-grid {
        --num-cols: 2;
        --row-height: 150px;
    }
}

/* Footer */

.footer {
    background: #111;
    color: var(--clr-accent);
    text-align: center;
    padding: 2.5em 0;
    font-size: var(--fs-h3);
}

.footer a { 
    color: inherit;
    text-decoration: none;
}

.footer__link {
    font-weight: var(--fw-bold);
}

.footer__link:hover,
.social-list__link:hover {
    opacity: 0.7;
}

.footer__link:hover {
    text-decoration: underline;
}

.social-list {
    list-style: none;
    display: flex;
    justify-content: center;
    margin: 2em 0 0;
    padding: 0;
}

.social-list__item {
    margin: 0 0.5;
}

.social-list__link {
    padding: 0.5em;
}

/* Portfolio Item Individual */

.portfolio-item-individual {
    padding: 0 2em 2em;
    max-width: 1000px;
    margin: 0 auto;
}

.portfolio-item-individual__buttons {
    list-style: none;
    display: flex;
    justify-content: space-evenly;
}

.portfolio-item-individual__buttons a {
    display: inline-block;
    padding: 0.5em 2.5em;
    background: var(--clr-accent);
    color: var(--clr-text);
    text-decoration: none;
    cursor: pointer;
    font-size: 0.8rem;
    text-transform: uppercase;
    letter-spacing: 2px;
    font-weight: var(--fw-bold);
    transition: transform 200ms ease-in-out;
}

.portfolio-item-individual__buttons a:hover {
    transform: scale(1.1);
}
